Stat
	var
		name
		value = 1
		modifier = 0
		multiplier = 1

	proc
		GetValue()
			return value * multiplier + modifier

		Reset()
			modifier = 0
			multiplier = 1

Attribute
	var
		name
		current
		maximum
		modifier = 0
		multiplier = 1

	proc
		GetCurrent()
			return GetMaximum() - maximum + current

		GetMaximum()
			return maximum * multiplier + modifier

		GetPercent(Decimals = 0)
			if(round(Decimals) != Decimals) // this line is basically an isint(num) proc
				CRASH("no decimals allowed in arg")
			return round(GetCurrent() / GetMaximum() * 100, 1 / (10 ** Decimals))

		IsFull()
			return GetCurrent() >= GetMaximum()

		IsEmpty()
			return GetCurrent() <= 0

		Reset()
			modifier = 0
			multiplier = 1

		Restore()
			current = maximum